%define name	opengroupware-env
%define version 1.0
%define cvs     20030721
%define release %{cvs}.1mdk

Summary:     OpenGroupware.org Execution Environment
Name:        %{name}
Version:     %{version}
Release:     %{release}
License:     GPL
URL:         http://www.opengroupware.org
Group:       Networking/Other
Prefix:      %{_libdir}/opengroupware.org
BuildRoot:   %{_tmppath}/%{name}-root
Source:      opengroupware-init.sh
Requires:    opengroupware-gstep-make, opengroupware-libfoundation
BuildRequires: opengroupware-gstep-make opengroupware-gstep-make-devel
BuildRequires: opengroupware-gstep-objc opengroupware-gstep-objc-devel
BuildRequires: opengroupware-libfoundation opengroupware-libfoundation-devel
Requires: shadow-utils

BuildArch: noarch

%description
This package contains the basic execution environment for the 
OpenGroupware.org environment.
It creates the 'ogo' user and the 'ogo' group, configures basic 
default values and creates config and logging directories.


%prep

%install

mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d
cp %{SOURCE0} ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d/ogo
chmod u+x ${RPM_BUILD_ROOT}%{_sysconfdir}/rc.d/init.d/ogo

export PATH='/usr/local/gcc-cache:/usr/local/bin:/usr/bin:/bin'
source %{prefix}/system/Makefiles/GNUstep.sh
export GNUSTEP_USER_ROOT="${RPM_BUILD_ROOT}%{prefix}"
export FORCED_ROOT="${RPM_BUILD_ROOT}%{prefix}"

mkdir -p ${GNUSTEP_USER_ROOT}

cat > ${GNUSTEP_USER_ROOT}/.bash_profile <<EOF
# OpenGroupware.org user profile

# new files can be read/written by the opengroupware user.
umask 007 

OGOSH="%{prefix}/OpenGroupware.org.sh"

if test -f \$OGOSH; then
  source \$OGOSH
else
  echo "Your environment seems to be broken as I can't find \$OGOSH"
fi

export SASL_PATH=\"\${GNUSTEP_USER_ROOT}/Library/Plugins/Plain.plugin/\$GNUSTEP_HOST_CPU/\$GNUSTEP_HOST_OS/\$LIBRARY_COMBO\"

export PYTHONPATH="\${GNUSTEP_USER_ROOT}/Tools"

export PILOTPORT="net:any:14238"
EOF

cat > $GNUSTEP_USER_ROOT/OpenGroupware.org.sh <<EOF
# OpenGroupware.org Installation Config 
# (use 'source OpenGroupware.org.sh' to load)
export FORCED_USER_ROOT=~ogo
source ~ogo/system/Makefiles/GNUstep.sh
export LD_ASSUME_KERNEL=2.4.2
IFS=''
unset IFS
EOF

mkdir -p ${RPM_BUILD_ROOT}%{_var}/spool/opengroupware.org/news
mkdir -p ${RPM_BUILD_ROOT}%{_var}/spool/opengroupware.org/documents
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/opengroupware.org

%pre
if test "x${RPM_INSTALL_PREFIX}" = "x"; then
  RPM_INSTALL_PREFIX="%{prefix}"
fi

SYSROOT=$RPM_INSTALL_PREFIX/system
GSCFG="$SYSROOT/Makefiles/GNUstep.sh"
source $GSCFG

/usr/sbin/groupadd -g 92 ogo  2> /dev/null || :
/usr/sbin/useradd -u 92 -g 92 -s /sbin/nologin -c "OpenGroupware.org User" -M -r -d $RPM_INSTALL_PREFIX ogo 2>/dev/null || :


/bin/true


%post
if test "x${RPM_INSTALL_PREFIX}" = "x"; then
  RPM_INSTALL_PREFIX="%{prefix}"
fi

INSTALLPATH="$RPM_INSTALL_PREFIX"

if test "x$INSTALLPATH" = "x"; then
  echo "Post: Couldn't detect installation path..."
fi

SYSROOT=$RPM_INSTALL_PREFIX/system
GSCFG="$SYSROOT/Makefiles/GNUstep.sh"
source $GSCFG

if [ ! -f $GNUSTEP_USER_ROOT/.bashrc ]; then
	ln -sf $GNUSTEP_USER_ROOT/.bash_profile $GNUSTEP_USER_ROOT/.bashrc
fi

if [ -d $RPM_INSTALL_PREFIX/news -a ! -L $RPM_INSTALL_PREFIX/news ]; then 
	mv $RPM_INSTALL_PREFIX/news/* %{_var}/spool/opengroupware.org/news || mv $RPM_INSTALL_PREFIX/news $RPM_INSTALL_PREFIX/news.old
	rm -fr $RPM_INSTALL_PREFIX/news
fi
if [ ! -L $RPM_INSTALL_PREFIX/news ];then 
	ln -fs %{_var}/spool/opengroupware.org/news $RPM_INSTALL_PREFIX/news
fi

if [ -d $RPM_INSTALL_PREFIX/documents -a ! -L $RPM_INSTALL_PREFIX/documents ]; then
	mv $RPM_INSTALL_PREFIX/documents/* %{_var}/spool/opengroupware.org/documents || mv $RPM_INSTALL_PREFIX/documents $RPM_INSTALL_PREFIX/documents.old
	rm -fr $RPM_INSTALL_PREFIX/documents
fi
if [ ! -L $RPM_INSTALL_PREFIX/documents ]; then 
	ln -s %{_var}/spool/opengroupware.org/documents $RPM_INSTALL_PREFIX/documents
fi

if [ -d $RPM_INSTALL_PREFIX/.libFoundation -a ! -L $RPM_INSTALL_PREFIX/.libFoundation ]; then
	mv $RPM_INSTALL_PREFIX/.libFoundation/* %{_sysconfdir}/opengroupware.org && rm -fr $RPM_INSTALL_PREFIX/.libFoundation
fi

if [ ! -L $RPM_INSTALL_PREFIX/.libFoundation ] ;then 
	ln -fs %{_sysconfdir}/opengroupware.org $RPM_INSTALL_PREFIX/.libFoundation 
fi


su - ogo -s /bin/bash -c "
source ~/OpenGroupware.org.sh
RES=`Defaults read NSGlobalDomain LSAdaptor 2>/dev/null`

if test \"x$RES\" = \"x\"; then
  Defaults write NSGlobalDomain LSAdaptor PostgreSQL72
  Defaults write NSGlobalDomain LSModel OpenGroupware.org_PostgreSQL
  Defaults write NSGlobalDomain LSModelName OpenGroupware.org_PostgreSQL
  Defaults write NSGlobalDomain NGBundlePath \"$RPM_INSTALL_PREFIX/Library/OpenGroupware.org\"
  Defaults write NSGlobalDomain LSAttachmentPath \"%{_var}/spool/opengroupware.org/documents/\"
  Defaults write NSGlobalDomain LSConnectionDictionary    \"{databaseName = ogo; hostName = localhost; password = \\\"\\\"; port = 5432; userName = ogo}\"
fi

RES=`Defaults read NSGlobalDomain LSNewsImagesUrl 2>/dev/null`

if test \"x$RES\" = \"x\"; then
  Defaults write NSGlobalDomain LSNewsImagesUrl \"/ArticleImages\"
  Defaults write NSGlobalDomain LSNewsImagesPath \"%{_var}/spool/opengroupware.org/news/\"
fi

RES=`Defaults read NSGlobalDomain XMLReader 2>/dev/null`

if test \"x$RES\" = \"x\"; then
  Defaults write NSGlobalDomain XMLReader libxmlSAXDriver
fi
"

/bin/true


%files
%defattr(-,root,root,-)
%config %{prefix}/.bash_profile
%config %{prefix}/OpenGroupware.org.sh
%defattr(-,ogo,ogo,-)
%{_var}/spool/opengroupware.org
%{_sysconfdir}/opengroupware.org
%config	%{_sysconfdir}/rc.d/init.d/ogo

%clean
rm -fr $RPM_BUILD_ROOT

%changelog
* Mon Sep 1 2003 Austin Acton <aacton@yorku.ca> 1.0-20030721.1mdk
- from Spencer Anderson <sdander@oberon.ark.com> :
  - initial Mandrake release
  - based on Redhat specfile

